-- updates for 6.3
CREATE TABLE TEMPLATE_MAPPING(
TEMPLATE_ID bigint NOT NULL ,
COLUMN_NAME varchar(50) NOT NULL ,
COL_DESC nvarchar(255) NOT NULL ,
COMPONENT_ID varchar(50) NOT NULL ,
COMPONENT_TYPE varchar(50) NOT NULL ,
CON_ID bigint NOT NULL ,
ITEM_SCHEME_ID bigint NOT NULL ,
PRIMARY KEY (TEMPLATE_ID))
;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_ITEM_SCHEME_TEMPLATE FOREIGN KEY (ITEM_SCHEME_ID) REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_CON_ID_TEMPLATE FOREIGN KEY (CON_ID) REFERENCES CONCEPT (CON_ID)

;

ALTER TABLE TEMPLATE_MAPPING ADD CONSTRAINT FK_COMPONENT_COMMON_TEMPLATE FOREIGN KEY (TEMPLATE_ID) REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

CREATE TABLE TM_TRANSCODING(
TEMPLATE_ID bigint NOT NULL ,
LOCAL_CODE nvarchar(150) NOT NULL ,
DSD_CODE varchar(150) NOT NULL ,
PRIMARY KEY (TEMPLATE_ID,LOCAL_CODE))
;

ALTER TABLE TM_TRANSCODING ADD CONSTRAINT FK_TEMPLATE_TRANSCODING FOREIGN KEY (TEMPLATE_ID) REFERENCES TEMPLATE_MAPPING (TEMPLATE_ID)
ON DELETE CASCADE
;

CREATE TABLE TM_TIME_TRANSCODING(
TEMPLATE_ID bigint NOT NULL ,
FREQ varchar(5) NOT NULL ,
IS_DATE int NOT NULL ,
Y_START bigint NULL ,
Y_LENGTH bigint NULL ,
P_START bigint NULL ,
P_LENGTH bigint NULL ,
PRIMARY KEY (TEMPLATE_ID,FREQ))
;
ALTER TABLE TM_TIME_TRANSCODING ADD CONSTRAINT FK_TEMPLATE_TIME FOREIGN KEY (TEMPLATE_ID) REFERENCES TEMPLATE_MAPPING (TEMPLATE_ID)
ON DELETE CASCADE

;
DROP PROCEDURE IF EXISTS INSERT_TEMPLATE_MAPPING
;

CREATE PROCEDURE INSERT_TEMPLATE_MAPPING(
IN p_column_name varchar(50),
IN p_col_desc nvarchar(255),
IN p_component_id varchar(50),
IN p_component_type varchar(50),
IN p_con_id bigint,
IN p_item_scheme_id bigint,
OUT p_pk bigint)
BEGIN
		call INSERT_COMPONENT_COMMON(p_pk);
		INSERT INTO TEMPLATE_MAPPING (TEMPLATE_ID,COLUMN_NAME,COL_DESC,COMPONENT_ID,COMPONENT_TYPE,CON_ID,ITEM_SCHEME_ID) VALUES (p_pk, p_column_name, p_col_desc, p_component_id, p_component_type, p_con_id, p_item_scheme_id);
END;

;

-- always last
update DB_VERSION SET VERSION = '6.3'
;

